using System;

namespace Explorer.Engine
{
	public interface ICountedPointer
	{
		void AddRef();
		bool Release();
	}
	
	public class Counter: ICountedPointer
	{
		private int _counter = 0;
		public void AddRef()
		{
			_counter++;	
		}
		
		public bool Release()
		{
			_counter--;
			if (_counter <= 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	
	public interface IRawFileSystem
	{
		Model.Entries CreateList(string folder);
		Model.Entry GetInfo(string entryName);
		void CreateDirectory(string folderName);
		void DeleteFile(string fileName);
		void DeleteDirectory(string folderName);
		System.IO.Stream OpenFile(string fileName, System.IO.FileMode mode, System.IO.FileAccess access, System.IO.FileShare share);
		string GetBaseFileName(string fileName, out IRawFileSystem container);
	}
	
	public interface IFileSystem: IRawFileSystem, IDisposable, ICountedPointer
	{
		void Open();
		void GetContainerInfo(string path, out string container, out string containerPath);
	}
}
