using System;
using System.Drawing;
using System.Collections;
using Quest.Atomic;

namespace Quest.Atomic.Graph2D
{
	public class Graph: Quest.Graph2D.Graph
	{
		public Graph()
		{
		}

		public Atom this[Node item]
		{
			get
			{
				return (item == null) ? null : item.Data;
			}
		}

		public Node this[Atom item]
		{
			get
			{
				if (item == null) return null;

				foreach(Node n in this.Nodes)
				{
					if(n.Data == item) return n;
				}
				return null;
			}
		}

		public string NodeLabel(Atom item, string name)
		{
			// TUNE:
			/*
			if(name == "")
			{
				return String.Format("({0})", item.ID);
			}
			else
			{
				return String.Format("{0}({1})", name, item.ID);
			}
			*/
			return name;
		}

		public Node New(Atom item, string name)
		{
			Node node = new Node();
			node.Data = item;
			Nodes.Add(node);
			node.Label = NodeLabel(item, name);
			return node;
		}

		public Node New(Atom item)
		{
			return New(item, "");
		}

		public Quest.Graph2D.Edge New(Node nodeFrom, string key, Atom to)
		{
			Node nodeTo = this[to];
			if (nodeTo == null)
			{
				return null;
			}
			else
			{
				return New(nodeFrom, key, nodeTo);
			}
		}

		public void Remove(Node nodeFrom, string key, Atom to)
		{
			Remove(nodeFrom, key, this[to]);
		}
	}
}
