using System;

namespace Structure.Graph2D.IO
{
	public abstract class WriterBase: IWriter
	{
		private	System.Windows.Forms.Control _control;
		private System.Drawing.Graphics _canvas;
		
		protected System.Drawing.Graphics Canvas
		{
			get
			{
				if (_canvas == null)
				{
					_control = new System.Windows.Forms.Control();
					_canvas = _control.CreateGraphics();
				}
				return _canvas;
			}
		}
		
		protected WriterBase()
		{
		}
		
		public abstract void Write(Node item);
		
		public abstract void Write(Edge item);
		
		public virtual void Close()
		{
			if (_canvas != null)
			{
				_canvas.Dispose();
				_canvas = null;
			}
			if (_control != null)
			{
				_control.Dispose();
				_control = null;
			}
		}
		
		#region IDisposable interface
		public void Dispose()
		{
			Dispose(true);
			GC.SuppressFinalize(this);
		}

		private void Dispose(bool disposing)
		{
			Close();
		}

		~WriterBase()
		{
			Dispose(false);
		}
		#endregion
	}
}
